#include "ell/StateCollector.hh"

namespace ell
{

	SC_Counting::SC_Counting()
	 :	lastAdded(NULL), stateCount(0)
	{
	}
	
	SC_Counting::~SC_Counting()
	{
		if (lastAdded != NULL) {
			delete lastAdded;
			lastAdded = NULL;
		}
	}

	  // This function is used to track all added States.
	  // @param s the State to add
	void 
	SC_Counting::add(const State& s) {
		lastAdded = s.clone(lastAdded);
		stateCount++;
	}
	
	  // Returns number of added States.
	  // @return the number of added states
	size_t 
	SC_Counting::size() const {
		return stateCount;
	}
	 
	  // Returns last added State.
	  // @return the last added State
	const State* const 
	SC_Counting::getLastAdded() const {
		return lastAdded;
	}
	
}
